﻿------------------------------------------------------------------------------------
-- NiceColorize by Mr.Dio (MrDio#2565) Version 2.2 (20:50 24.03.2016)
------------------------------------------------------------------------------------
--
-- Changelog:
--
-- 1.0
----------------------------
-- + Add coloring and adding shadows for frames with the names of players and monsters
-- + Add group numbers to the names
--
-- 1.1
----------------------------
-- - Remove show group number in the arena
-- ! Fix group number after leaving the arena
-- + Add Fix standard raid frame bug
-- + Add coloring HP bars (player\target\focus)
-- + Add nice info to bars (player\target\focus)
--
-- 1.2
----------------------------
-- + Add Config
-- + Add Friend List Names Colorize
-- + Add Smooth to bars
-- + Add to all HP bars coloring
-- + Add More speed to update names color
--
-- 1.3
----------------------------
-- - Boss HP Bars colorize
-- + Some check
--
-- 1.3.1
----------------------------
-- ! Fix Raid Frame Names Colorizing
--
-- 1.4
----------------------------
-- + 6.0 support
-- ! Fix BossTarget Error
-- ! Fix death text on players\target target
-- ! Fix Blizzard Healthbar Text
--
-- 1.5
----------------------------
-- ! rewrote code for most functions
-- - Smooth bar :(
--
-- 2.0b
----------------------------
-- + Options
-- + Locale
-- ! rewrote code for most functions
--
-- 2.1
----------------------------
-- ! Bug fix
--
-- 2.2
----------------------------
-- ! BNet 6.2.4 Fix
--
------------------------------------------------------------------------------------
-- NiceColorize
------------------------------------------------------------------------------------

local NCFrame = CreateFrame("FRAME")

NCFrame:RegisterEvent("ADDON_LOADED")
NCFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

NCFrame:SetScript("OnEvent", function(Self, Event, ...)

	local Addon = ...
	local Load

	if (Event == "ADDON_LOADED") and (Addon == "NiceColorize") then
		if not NCConfigDB or NCConfigDef.Version > NCConfigDB.Version then
			NCConfigDB = CopyTable(NCConfigDef)
		end
		NCConfig = NCConfigDB
		if NiceColorizeLocale_Init() then
			if CreateOptions(NCConfig) then
				if NamesColorizeModule_Init(NCConfig.NamesColorize) then
					if BarsColorizeModule_Init(NCConfig.BarsColorize) then
						if FramesColorizeModule_Init(NCConfig.FramesColorize) then
							if IconsColorizeModule_Init(NCConfig.IconsColorize) then
								DEFAULT_CHAT_FRAME:AddMessage(GetAddOnMetadata(Addon, "Title").." v."..GetAddOnMetadata(Addon, "Version").." Loaded!")
								Load = true
							end
						end
					end
				end
			end
		end
	end
	
	if ( Event == "PLAYER_ENTERING_WORLD" and Load ) then
	
		if not IsAddOnLoaded("Blizzard_TimeManager") then
			LoadAddOn("Blizzard_TimeManager")
		end
	
		BarsColorizeModule_Update(NCConfig.BarsColorize)
		NamesColorizeModule_Update()
		FramesColorizeModule_Update(NCConfig.FramesColorize)
		IconsColorizeModule_Update()
	end
end)